/*
 *
 * Saryer.xs
 *
 * $Id: Saryer.xs,v 1.11 2005/07/10 17:19:01 tsuchiya Exp $
 *
 * Copyright: LGPL 
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include "sary.h"

/* for old version of perl (< 5.004_04?) */
#if !defined(PL_na) && defined(na)
#define PL_na na
#endif
#if !defined(PL_sv_undef) && defined(sv_undef)
#define PL_sv_undef sv_undef
#endif

MODULE = Search::Saryer		PACKAGE = Search::Saryer

PROTOTYPES: DISABLE

SV *
perl_saryer_new(target_file,array_file)
	char *target_file
	char *array_file

	PREINIT:
	SarySearcher *saryer;
	SV *sv;

	CODE:
	saryer = sary_searcher_new2(target_file,array_file);
	if (saryer == NULL) {
		RETVAL = &PL_sv_undef;
	} else {
		sv = newSViv((IV) saryer);
		RETVAL = sv;
	}

	OUTPUT:
		RETVAL

void
perl_saryer_destroy(saryer)
	IV saryer

	PREINIT:
	SarySearcher *ps;

	CODE:
	ps = (SarySearcher *) saryer;
	sary_searcher_destroy(ps);

void
perl_saryer_enable_cache(saryer)
	IV saryer

	PREINIT:
	SarySearcher *ps;

	CODE:
	ps = (SarySearcher *) saryer;
	sary_searcher_enable_cache(ps);

SV *
perl_saryer_search(saryer, pat, len)
	IV saryer
	char *pat
	int len

	PREINIT:
	SarySearcher *ps;
	gboolean ret;

	CODE:
	ps = (SarySearcher *) saryer;
	ret = sary_searcher_search2(ps, pat, len);
	if (ret) {
		RETVAL = newSVnv(1);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_icase_search(saryer, pat, len)
	IV saryer
	char *pat
	int len

	PREINIT:
	SarySearcher *ps;
	gboolean ret;

	CODE:
	ps = (SarySearcher *) saryer;
	ret = sary_searcher_icase_search2(ps, pat, len);
	if (ret) {
		RETVAL = newSVnv(1);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_line(saryer)
	IV saryer

	PREINIT:
	SarySearcher *ps;
	char *ret;

	CODE:
	ps = (SarySearcher *) saryer;
	ret = sary_searcher_get_next_line(ps);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_context_lines(saryer, bw, fw)
	IV saryer
	int bw
	int fw

	PREINIT:
	SarySearcher *ps;
	char *ret;

	CODE:
	ps = (SarySearcher *) saryer;
	ret = sary_searcher_get_next_context_lines(ps, bw, fw);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

SV *
perl_saryer_get_next_tagged_region(saryer, stag, etag)
	IV saryer
	char *stag
	char *etag

	PREINIT:
	SarySearcher *ps;
	char *ret;

	CODE:
	ps = (SarySearcher *) saryer;
	ret = sary_searcher_get_next_tagged_region(ps, stag, etag);
	if (ret) {
		RETVAL = newSVpv(ret, 0);
		g_free(ret);
	} else {
		RETVAL = &PL_sv_undef;
	}

	OUTPUT:
		RETVAL

void
perl_saryer_sort_occurrences(saryer)
	IV saryer

	PREINIT:
	SarySearcher *ps;

	CODE:
	ps = (SarySearcher *) saryer;
	sary_searcher_sort_occurrences(ps);
